Semaphore - lockfile/flock


 
Thread Tools Search this Thread
Top Forums UNIX for Advanced & Expert Users Semaphore - lockfile/flock
# 1  
Old 05-22-2015
Semaphore - lockfile/flock

Hi,

I have a process which can run one instance at a time. Currently we have multiple scripts trying to kickoff this process. I wanted to implement the semaphore mechanism to achieve this.

I was going through few examples. The below code seems to be reasonable solution.

Code:
              ...
              lockfile important.lock
              ...
              access_"important"_to_your_hearts_content
              ...
              rm -f important.lock

But I am concerned about limitations, eg. we do not have much control on the filename (in the above case, "important")

Especially our team who maintains the application in Production are not experts.

Which technique (command) would you recommend (least errors and less experience to maintain)
# 2  
Old 05-22-2015
I cannot see the problems / limitations that you quote. There are other lock mechanisms, but they are more sophisticated, so possibly less suitable for your team. What's the problem with the file name?
# 3  
Old 05-22-2015
With any POSIX-conforming shell, you can also use:
Code:
set -C	# Set noclobber mode.  (Attempts to overwrite an existing file fail.)
if echo $$ > lockfile
then	printf 'Process ID %d now has the lock.\n' $$
else	read pid < lockfile
	printf 'Process ID %d holds the lock; exiting.\n' "$pid"
	exit 1
fi
set +C	# Return to default (no noclobber) mode.
trap 'rm -rf lockfile' EXIT	# Remove the lock when we exit.

This works to guarantee that only one process holds the lock (assuming that lockfile is an absolute pathname), but the read could fail if the lock was held at the time you requested the lock but the lock holder terminated before the read was processed. (So, you need to verify that the read worked rather than assume that it will always succeed.)
# 4  
Old 05-23-2015
I suggest using the flock(1) command.

Last edited by frank_rizzo; 05-23-2015 at 09:50 AM.. Reason: add man page link
# 5  
Old 05-30-2015
Or use mkdir
Code:
#!/bin/sh
trap "rmdir lockdir" EXIT
if mkdir lockdir
then
  echo start process
fi

# 6  
Old 05-30-2015
Quote:
Originally Posted by MadeInGermany
Or use mkdir
Code:
#!/bin/sh
trap "rmdir lockdir" EXIT
if mkdir lockdir
then
  echo start process
fi

This is backwards. If you do it this way, you will destroy a lock set by another process if you don't get the lock... You only want to set that trap after you acquire the lock.
Code:
#!/bin/sh
if mkdir lockdir
then
  trap "rmdir lockdir" EXIT
  echo start process
fi

This User Gave Thanks to Don Cragun For This Post:
Login or Register to Ask a Question

Previous Thread | Next Thread

7 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

Flock preventing function to work

Hi i have a script that check pings and i use flock to so the script wont run multipul times : its not the whole script but this is the idea : ( flock -x -w 3 200 || exit 1 /usr/sbin/fping -c$count -i$interval -a $hosts > $FILE1 2>&1 ) 200>/var/lock/.myscript.exclusivelock now i... (4 Replies)
Discussion started by: batchenr
4 Replies

2. Shell Programming and Scripting

Use of flock command for whole script

I'm changing my mindset from a few big processes moving data from a few sources under an external, dependency-based scheduler to multiple processes moving data from many sources run by each client cron and possibly interfering with each other. It has the benefits of more granular code but I'm... (11 Replies)
Discussion started by: rbatte1
11 Replies

3. Shell Programming and Scripting

Help using Flock (file lock)

Hello, I have been working on using "flock"/file lock to prevent two instances of a bash script from being executed. Below is a simplified version of what I have to illustrate the flock part. It works as it is set up there below however the piece I am trying to figure out is how to get it to... (2 Replies)
Discussion started by: infrared013
2 Replies

4. Shell Programming and Scripting

Bash Lockfile Command

Hi, I am new to this forum, could any one please help me to understand the LOCKFILE command with an example and what exactly it is used for and how it is used. Thanks Reshu289 (4 Replies)
Discussion started by: Reshu289
4 Replies

5. UNIX for Advanced & Expert Users

Testing privileges -lock lockfile /var/lock/subsys/..- Permission denied

Hi all, I have to test some user priviliges. The goal is to be sure that an unauthorized user can't restart some modules (ssh, mysql etc...). I'm trying to automate it with a shell script but in same cases I got the syslog broadcast message. Is there any way to simply get a return code... (3 Replies)
Discussion started by: Dedalus
3 Replies

6. Shell Programming and Scripting

"lockfile: command not found"

Just tried out the following code from "Using lockfiles in shell scripts": #!/bin/bash if ; then echo "File exists" else echo "File does not exists. Create file now." echo 1 > number.txt fi lockfile script.lock a=$(/usr/bin/tail -n 1 number.txt) if ; then... (1 Reply)
Discussion started by: courteous
1 Replies

7. Shell Programming and Scripting

Retry every ten seconds while lockfile present

Hi, I have written below check lockfile script but need some tweaking on it. If there is a lockfile from present, I need the script to retry every 10 seconds to see if the lockfile is still there. After 120 seconds it should send an email. In my current version, if the script encounters... (6 Replies)
Discussion started by: Meert
6 Replies
Login or Register to Ask a Question